
//
// Cleanup, Walter Kosters, 18.9.2010
//

#include <iostream>
#include <cstring>
using namespace std;

const int MAX = 3000;
string words[MAX];
bool away[MAX];
int number;

// do words start ... theend, with start <= theend,
// assuming that the first len string elements of all
// words in this interval are the same
void doit (int start, int theend, unsigned int len) {
  int i, nraway = 0, nrstay = 0, locstart, loctheend;
  if ( start == theend ) { // just one word
    if ( away[start] )
      number++;
    return;
  }//if
  if ( words[start].length ( ) == len ) {
    for ( i = start + 1; i <= theend; i++ )
      if ( away[i] )
        nraway++;
      else
        nrstay++;
    if ( away[start] ) {
      number++;
      if ( nrstay == 0 )
	return;
    }//if
    else if ( nraway == 0 )
      return;
    locstart = loctheend = start+1;
  }//if
  else {
    for ( i = start; i <= theend; i++ )
      if ( away[i] )
        nraway++;
      else
        nrstay++;
    if ( nrstay == 0 ) {
      number++;
      return;
    }//if
    if ( nraway == 0 )
      return;
    locstart = loctheend = start;
  }//else
  for ( i = locstart+1; i <= theend; i++ ) {
    if ( words[i][len] == words[locstart][len])
      loctheend = i;
    else {
      doit (locstart,loctheend,len+1);
      locstart = loctheend = i;
    }//else
  }//for
  doit (locstart,loctheend,len+1);
}//doit

int main ( ) {
  int cases, casenr, i, j, h, N1, N2;
  string tempw;
  bool tempb;
  cin >> cases;
  for ( casenr = 0; casenr < cases; casenr++ ) {
    cin >> N1;
    for ( i = 0; i < N1; i++ ) {
      cin >> words[i]; 
      away[i] = true;
    }//for
    cin >> N2;
    for ( ; i < N1+N2; i++ ) {
      cin >> words[i]; 
      away[i] = false;
    }//for
    if ( N2 == 0 ) { // just rm * suffices
      cout << "1" << endl;
      continue;
    }//if
    // (shell)sort array words (together with array away)
/*    for ( i = 0; i < N1+N2-1; i++ ) {  // good old bubblesort
      for ( j = 0; j < N1+N2-i-1; j++ ) 
        if ( words[j] > words[j+1] ) {
	  tempw = words[j];
	  words[j] = words[j+1];
	  words[j+1] = tempw;
	  tempb = away[j];
	  away[j] = away[j+1];
	  away[j+1] = tempb;
	}//if
    }//for
*/
    h = N1+N2;
    while ( h > 1 ) {
      h = h / 2;
      for ( i = h; i < N1+N2; i++ ) {
        tempw = words[i]; tempb = away[i]; j = i - h;
        while ( ( j >= 0 ) && ( words[j] > tempw ) ) {
          words[j+h] = words[j];
	  away[j+h] = away[j];
          j = j - h;
        }//while
        words[j+h] = tempw;
        away[j+h] = tempb;
      }//for
    }//while
    number = 0;
    doit (0,N1+N2-1,0);
    cout << number << endl;
  }//for
  return 0;
}//main

