// http://wordaligned.org/articles/the-maximum-subsequence-problem
//
// HJH in Quadratische tijd
//
#include <iostream>
#include <limits>
using namespace std;

const 
  int MaxN = 1000001;

  int a[MaxN];

int main ()
{
  int Inst, NInst;
  int Len, i,j ;
  int MaxSeq, Sum;
  int MaxStart, MaxEnd;

//TST  cout << endl << "maxint: " << std::numeric_limits<int>::max() << endl;

  // number problem instances
  cin >> NInst;
//TST  cout << "number of instances: " << NInst << endl;

  for ( Inst=1; Inst<=NInst; Inst++ )
  {
    MaxSeq = 0;
    Sum = 0;
    MaxStart = 0; MaxEnd = 0;
    // read length problem
    cin >> Len;
//TST    cout << "instance #" << Inst << endl;
    // reading numbers
    for ( i=1; i<=Len; i++ ) { cin >> a[i]; }

    for ( i=1; i<=Len; i++ )
    // bepaal sommen die beginnen op positie i
    // maar alleen als het eerste getal niet negatief is
    // anders kan het beter
    {
      if ( a[i] >= 0 )
      {
        Sum = 0;
        for  ( j=i; j<=Len; j++ )
	{
          Sum += a[j]; 
          if (Sum > MaxSeq) 
          { MaxSeq = Sum; 
            MaxStart = i;
            MaxEnd = j;
	  }
        }
      }
    }
    cout << MaxStart << " " << MaxEnd << endl;

//TST   
//    cout << "maxsom: " << MaxSeq 
//         << " [" << MaxStart << "," << MaxEnd << "]"
//         << endl;
//   
//    cout << "input sequence: ";
//    for ( i=1; i<=Len; i++ ) 
//    { if (MaxStart == i) { cout << "[ "; }
//      cout << a[i] << " "; 
//      if (MaxEnd == i) { cout << "] "; }
//    }
//    cout << endl;
  }
 
}
