import java.io.* ;

public class acrobat {

	static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	
	public static void main(String[] args) throws Exception {
		int n = readInt();
		for (int i=0;i<n;i++)			
			doShizzle();
	}
	
	public static int readInt() throws Exception {
		return Integer.parseInt(in.readLine());
	}
	
	static int[][][] points = new int[2][10000][2]; //picture 1 or 2, index, x and y
	static int n;

	private static void quicksort(int k, int low, int high) {
		int i = low, j = high;
		int pivot = low + (high-low)/2;

		while (i <= j) {
			while ((points[k][i][0]<points[k][pivot][0])||
					((points[k][i][1]<points[k][pivot][1])&&(points[k][i][0]==points[k][pivot][0]))) {
				i++;
			}
			while ((points[k][j][0]>points[k][pivot][0])||
					((points[k][j][1]>points[k][pivot][1])&&(points[k][j][0]==points[k][pivot][0]))) {
				j--;
			}

			if (i <= j) {
				int x = points[k][i][0];
				points[k][i][0] = points[k][j][0];
				points[k][j][0] = x;
				x = points[k][i][1];
				points[k][i][1] = points[k][j][1];
				points[k][j][1] = x;
				i++;
				j--;
			}
		}

		if (low < j)
			quicksort(k, low, j);
		if (i < high)
			quicksort(k, i, high);
	}

	public static void sort(int k) {
		quicksort(k, 0, n - 1);
	}
	
	private static void rotate(){
		for (int i=0;i<n;i++){
			int tmp = points[0][i][0];
			points[0][i][0] = - points[0][i][1];
			points[0][i][1] = tmp;
		}
	}
	
	private static boolean equal(){
		int[][] maxs = new int[2][2];
		int[][] mins = new int[2][2];
		for (int i=0; i<2; i++)
			for (int k=0; k<2; k++){
				maxs[i][k] = -100000;			
				mins[i][k] = 100000;			
				for (int l=0; l<n; l++){
					maxs[i][k] = Math.max(maxs[i][k], points[i][l][k]);
					mins[i][k] = Math.min(mins[i][k], points[i][l][k]);
				}
			}
		double dx = 0, dy = 0;
		if ((maxs[0][0]-mins[0][0])==0){ 
			if (maxs[1][0]-mins[1][0]!=0) return false; 
		}else
			dx = mins[0][0]*(maxs[1][0]-mins[1][0])/(double)(maxs[0][0]-mins[0][0]) - mins[1][0];
		if ((maxs[0][1]-mins[0][1])==0){ 
			if (maxs[1][1]-mins[1][1]!=0) return false; 
		}else
			dy = mins[0][1]*(maxs[1][1]-mins[1][1])/(double)(maxs[0][1]-mins[0][1]) - mins[1][1];
		
		if ((maxs[0][0]-mins[0][0])*(maxs[1][1]-mins[1][1])!=(maxs[1][0]-mins[1][0])*(maxs[0][1]-mins[0][1])) return false;
		for (int i=0; i<n; i++){
			if (Math.abs((points[1][i][0]+dx)*(maxs[0][0]-mins[0][0])- points[0][i][0]*(maxs[1][0]-mins[1][0]))>0.0000001) return false;
			if (Math.abs((points[1][i][1]+dy)*(maxs[0][1]-mins[0][1])- points[0][i][1]*(maxs[1][1]-mins[1][1]))>0.0000001) return false;
		}
	    return true;
	}
	
	private static void doShizzle() throws Exception {
		n = readInt();
        for (int i=0;i<n*2;i++){
        	String readLine = in.readLine();
        	String[] split = readLine.split(" ");
        	points[i/n][i%n][0] = Integer.parseInt(split[0]);
        	points[i/n][i%n][1] = Integer.parseInt(split[1]);
        }
    	sort(1);
        for (int i=0;i<4;i++){
        	for (int k=0;k<10;k++){
        	sort(0);
        	sort(1);}
        	if (equal()) {
        		System.out.println("okay");
        		return;
        	}
        	rotate();
        }
		System.out.println("mismatch!");
	}
}
