import java.io.* ;

//Read and write in Log(N)^2, with N size of board. Credits for algorithm to JB
public class fantasy2 {

	static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	
	public static void main(String[] args) throws Exception {
		int n = readInt();
		for (int i=1;i<1025;i++)
			for (int k=1;k<1025;k++)
				if ((i%2)==(k%2)) put(i,k,1);
		for (int i=0;i<n;i++)
			doShizzle();
	}
	
	public static int readInt() throws Exception {
		return Integer.parseInt(in.readLine());
	}
	
	static int[][] values = new int[1025][1025];
	static int[][] sums = new int[1025][1025];
	
	private static void put(int x, int y, int value){
		if (values[x][y]!=value){
			value = value - values[x][y];
			values[x][y] += value;
			int yt;
		    while(x <= 1024) {
				yt = y;
				while(yt <= 1024) {
			        sums[x][yt] += value;
					yt += (yt & -yt);
				}
				x += (x & -x);
		    }
		}
	}
	
	private static int sum(int x, int y){
		if ((x<0)|(y<0)) return 0;
		int answer = 0, yt = y;
	    while(x > 0) {
			yt = y;
			while(yt > 0) {
		        answer += sums[x][yt];
				yt -= (yt & -yt);
			}
	        x -= (x & -x);
	    }
	    return answer;
	}
	
	private static int get(int x1, int y1, int x2, int y2){
		return sum(x2,y2)-sum(x1-1,y2)-sum(x2,y1-1)+sum(x1-1,y1-1);
	}
	
	private static void doShizzle() throws Exception {
		String readLine = in.readLine();
		String[] split = readLine.split(" ");
        int[] ints = new int[split.length-1];
        for (int i=1;i<split.length;i++)
        	ints[i-1] = Integer.parseInt(split[i]);
        
		if (split[0].charAt(0)=='A') put(ints[0],ints[1],1);
		if (split[0].charAt(0)=='B') put(ints[0],ints[1],0);
		if (split[0].charAt(0)=='R') {
			int a = get(ints[0],ints[1],ints[2],ints[3]);
			System.out.println(a+" "+((ints[3]-ints[1]+1)*(ints[2]-ints[0]+1)-a));
		}
	}
}
