// Problem: My Cousin Obama
// Author: Jeroen Bransen
// Date: 1 October 2010

import java.io.*;

public class J {
  public static int[] father;
  public static int[] mother;
  public static boolean[] done;
  public static int[] mem;
  public static int B0;

  public static void main(String[] args) throws Exception {
    BufferedReader in = new BufferedReader(new
InputStreamReader(System.in));
    int tests = Integer.parseInt(in.readLine());
    while(tests-- > 0) {
      int N = Integer.parseInt(in.readLine());
      String[] p = in.readLine().split(" ");
      int A0 = Integer.parseInt(p[0]);
      B0 = Integer.parseInt(p[1]);
      father = new int[N+1];
      mother = new int[N+1];
      for(int i = 0; i < N; i++) {
        p = in.readLine().split(" ");
        father[i+1] = Integer.parseInt(p[0]);
        mother[i+1] = Integer.parseInt(p[1]);
      }
      done = new boolean[N+1];
      mem = new int[N+1];
      int ret = rec(A0);
      if(ret == -1)
        System.out.println("no ancestor");
      else
        System.out.println(ret);
    }
    in.close();
  }

  public static int rec(int a) {
    if(done[a])
      return mem[a];
    done[a] = true;
    mem[a] = -1;
    if(father[a] == B0 || mother[a] == B0)
      return mem[a] = 0;
    if(father[a] != 0 && rec(father[a]) != -1 && (mem[a] == -1 ||
rec(father[a]) < mem[a]))
      mem[a] = rec(father[a]);
    if(mother[a] != 0 && rec(mother[a]) != -1 && (mem[a] == -1 ||
rec(mother[a]) + 1 < mem[a]))
      mem[a] = rec(mother[a]) + 1;
    return mem[a];
  }
}
