// @author ftakes
#include<iostream>
#include<string.h>
#include<limits.h>
#include<algorithm>
using namespace std;

const int maxN = 1000001;
int t, N, A, B, father[maxN+1], mother[maxN+1], dp[maxN+1];
bool isWoman[maxN];

int rec(int i) {
    if(i == 0)
        return maxN;
    isWoman[mother[i]] = true;
    if(dp[i] > -1)
        return dp[i];
    if(i == B) {
        dp[i] = -1;
        if(isWoman[i])
            return -1;
        return 0;
    } // if
    dp[i] = min(rec(father[i]), rec(mother[i])+1);
    return dp[i];
} // rec

int main() {
    cin >> t;
    while(t--) {
        cin >> N >> A >> B;
        memset(dp, -1, sizeof(dp));
        memset(isWoman, false, sizeof(isWoman));
        for(int i=1; i<=N; i++) 
            cin >> father[i] >> mother[i];
        int result = rec(A);
        if(result >= maxN)
            cout << "no ancestor" << endl;
        else
            cout << result << endl;
    } // while
    return 0;
} // main
