/*
 * BAPC 2010 Preliminaries
 * Jeroen Bransen
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXN 500
#define MAXM 100000

#define MAX(a,b) ((a) > (b) ? (a) : (b))

int s[MAXN];
int mem[2][MAXM];

void testcase() {
	int n, m, i, j, k;
	scanf("%d %d\n", &n, &m);
	for(i=0;i<n;i++)
		scanf("%d", &s[i]);
	memset(mem, 0, sizeof(mem));
	k = 0;
	for(i=0;i<n;i++) {
		for(j=0;j<m;j++)
			mem[k][j] = mem[1-k][j];
		for(j=0;j<m;j++)
			if(mem[1-k][j]>0 || j==0)
				mem[k][(j+s[i])%m] = MAX(mem[k][(j+s[i])%m], mem[1-k][j]+1);
		k = 1-k;
	}
	printf("%d\n", mem[1-k][0]);
}

int main() {
	int t;
	scanf("%d\n", &t);
	while(t--) testcase();
	return 0;
}
