import java.io.* ;


public class serialnumber_ws {

	static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	
	public static void main(String[] args) throws Exception {
		int n = readInt();
		for (int i=0;i<n;i++)
			doShizzle();
	}
	
	public static int readInt() throws Exception {
		return Integer.parseInt(in.readLine());
	}
	
	public static int[] readInts() throws Exception {
		String readLine = in.readLine();
		String[] split = readLine.split(" ");
		
		int[] ints = new int[split.length];
		
		for (int i=0;i<split.length;i++) {
			ints[i] =  Integer.parseInt(split[i]);
		}
		return ints;
	}
	
	private static void doShizzle() throws Exception {
		String readLine = in.readLine();
		String[] split = readLine.split(" ");
		int n = Integer.parseInt(split[0]);
		int m = Integer.parseInt(split[1]);
		int max = 0;
        int[] s = readInts();
		
		int plus = 200000 - 200000 % m;
		
		int[][] best = new int[2][m]; //best[k] gives best so far with remainder k

		best[0][0] = 1;
		for (int i=0;i<n;i++) //include guitar i
			for (int k=0;k<m;k++)
			    if (best[i%2][(k-s[i]+plus)%m]>0) {//that means it is possible
			    	best[(i+1)%2][k] = Math.max(best[i%2][k],best[i%2][(k-s[i]+plus)%m]+1);
			    }else {
					  best[(i+1)%2][k] = best[i%2][k];
			    }
			
		System.out.println(best[n%2][0] - 1);
	}
}
