// http://wordaligned.org/articles/the-maximum-subsequence-problem
#include <iostream>
#include <limits>
using namespace std;

const 
  int MaxN = 1000001;

  int a[MaxN];

int main ()
{
  int Inst, NInst;
  int Len, i;
  int MaxSeq, RunningSum;
  int MaxStart, MaxEnd, RunningStart;

//TST  cout << endl << "maxint: " << std::numeric_limits<int>::max() << endl;

  // number problem instances
  cin >> NInst;
//TST  cout << "number of instances: " << NInst << endl;

  for ( Inst=1; Inst<=NInst; Inst++ )
  {
    MaxSeq = 0;
    RunningSum = 0;
    MaxStart = 0; MaxEnd = 0; RunningStart = 1;
    // read length problem
    cin >> Len;
//TST    cout << "instance #" << Inst << endl;
    // reading numbers
    for ( i=1; i<=Len; i++ ) { cin >> a[i]; }

    for ( i=1; i<=Len; i++ )
    {
      if (RunningSum+a[i] >= 0)
      { 
        RunningSum += a[i]; 
      }
      else
      {
        RunningSum = 0;
        RunningStart = i+1;
      }
      if (RunningSum > MaxSeq) 
      { MaxSeq = RunningSum; 
        MaxStart = RunningStart;
        MaxEnd = i;
      }
    }
    cout << MaxStart << " " << MaxEnd << endl;

//TST   
//    cout << "maxsom: " << MaxSeq 
//         << " [" << MaxStart << "," << MaxEnd << "]"
//         << endl;
//   
//    cout << "input sequence: ";
//    for ( i=1; i<=Len; i++ ) 
//    { if (MaxStart == i) { cout << "[ "; }
//      cout << a[i] << " "; 
//      if (MaxEnd == i) { cout << "] "; }
//    }
//    cout << endl;
  }
 
}
