import java.io.*;
import java.util.*;

public class acrobatreader_jb {

	static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
	
	public static void main(String[] args) throws Exception {
		int t = readInt();
		for(int i = 0; i < t; i++)
		   System.out.println(testcase() ? "okay" : "mismatch!");
	}
	
	public static boolean testcase() throws Exception {
	   int n = readInt();
	   Point[] pts1 = new Point[n];
	   Point[] pts2 = new Point[n];
	   for(int i = 0; i < n; i++)
	      pts1[i] = readPoint();
	   for(int i = 0; i < n; i++)
	      pts2[i] = readPoint();
	   Arrays.sort(pts1);
	   Arrays.sort(pts2);
	   for(int i = 0; i < 4; i++) {
	      if(i > 0) {
	         for(int j = 0; j < n; j++)
	            pts1[j].rotate();
	         Arrays.sort(pts1);
	      }
	      int minx1 = pts1[0].X;
	      int maxx1 = pts1[0].X;
	      int miny1 = pts1[0].Y;
	      int maxy1 = pts1[0].Y;
	      int minx2 = pts2[0].X;
	      int maxx2 = pts2[0].X;
	      int miny2 = pts2[0].Y;
	      int maxy2 = pts2[0].Y;
	      for(int j = 1; j < n; j++) {
	         minx1 = Math.min(minx1, pts1[j].X);
	         maxx1 = Math.max(maxx1, pts1[j].X);
	         miny1 = Math.min(miny1, pts1[j].Y);
	         maxy1 = Math.max(maxy1, pts1[j].Y);
	         minx2 = Math.min(minx2, pts2[j].X);
	         maxx2 = Math.max(maxx2, pts2[j].X);
	         miny2 = Math.min(miny2, pts2[j].Y);
	         maxy2 = Math.max(maxy2, pts2[j].Y);
	      }
      	if((maxx2 - minx2) * (maxy1 - miny1) != (maxy2 - miny2) * (maxx1 - minx1))
      		continue;
	      boolean ok = true;
	      for(int j = 1; j < n; j++) {
      		if((pts1[j].X - pts1[0].X) * (maxx2 - minx2) != (pts2[j].X - pts2[0].X) * (maxx1 - minx1)
   			|| (pts1[j].Y - pts1[0].Y) * (maxy2 - miny2) != (pts2[j].Y - pts2[0].Y) * (maxy1 - miny1)) {
   			   ok = false;
   			   break;
   			}
	      }
	      if(ok) return true;
	   }
	   return false;
	}
	
	public static int readInt() throws Exception {
		return Integer.parseInt(in.readLine());
	}
	
   public static Point readPoint() throws Exception {
      String[] p = in.readLine().split(" ");
      return new Point(Integer.parseInt(p[0]), Integer.parseInt(p[1]));
   }
	
	static class Point implements Comparable<Point> {
	   public int X, Y;
	   
	   public Point(int x, int y) {
	      X = x; Y = y;
	   }
	   
	   public int compareTo(Point other) {
	      if(X != other.X)
	         return X - other.X;
	      return Y - other.Y;
	   }
	   
	   public void rotate() {
	      int tmp = X;
	      X = Y;
	      Y = -tmp;
	   }
	}
}